/*
 * Interprocess communication utilities.
 *
 * Copyright (C) 2021 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/sys/ipc.h>

#include "flexpage.h"



long ipc_prepare_flexpage(Flexpage *flexpage, offset_t offset,
                          offset_t max_offset, address_t hot_spot,
                          flags_t flags, l4_snd_fpage_t *region);

void ipc_unmap_flexpage(Flexpage *flexpage);

// vim: tabstop=4 expandtab shiftwidth=4
